diff --git a/src/common/resources/lang/en_US/item.lang b/src/common/resources/lang/en_US/item.lang
index 077012dc7..2f0bee17e 100644
--- a/src/common/resources/lang/en_US/item.lang
+++ b/src/common/resources/lang/en_US/item.lang
@@ -412,6 +412,9 @@ item.door.oak.painted.white.desc=Every house needs one.
 item.door.glass.name=Glass Door
 item.door.glass.desc=Great for aesthetics, terrible for privacy.
 
+item.door.steel.name=Steel Door
+item.door.steel.desc=Hardened and robust.
+
 item.rope.name=Rope
 item.rope.desc=Strong enough to climb.
 
diff --git a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
index 9e60e6c09..e56e5db6c 100644
--- a/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
+++ b/src/main/java/net/betterthanadventure/utils/BiomeFinder.java
@@ -7,6 +7,7 @@ import net.minecraft.core.MinecraftAccessor;
 import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
@@ -78,7 +79,7 @@ public class BiomeFinder implements MinecraftAccessor {
                     worldFolder = new File(value);
                     break;
                 case "world-client":
-                    worldFolder = new File(Minecraft.getAppDir("minecraft-bta"), "saves/" + value);
+                    worldFolder = new File(Minecraft.getMinecraft(Minecraft.class).getMinecraftDir(), "saves/" + value);
                     break;
                 case "seed":
                     seed = parseSeed(value);
@@ -131,7 +132,7 @@ public class BiomeFinder implements MinecraftAccessor {
 
 		File worldDirectory;
 		try {
-			worldDirectory = new File(Minecraft.getAppDir("minecraft-bta"), "saves");
+			worldDirectory = new File(Minecraft.getMinecraft(Minecraft.class).getMinecraftDir(), "saves");
 		} catch (Exception e){
 			worldDirectory = new File("");
 		}
@@ -484,7 +485,7 @@ public class BiomeFinder implements MinecraftAccessor {
 		} else {
 			SaveFormatBase saveFormat = new SaveFormat19134(worldFolder.getParentFile());
 			LevelStorage saveHandler = saveFormat.getSaveHandler(worldFolder.getName(), false);
-			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), null, null);
+			world = new World(saveHandler, saveHandler.getLevelData().getWorldName(), saveHandler.getLevelData().getRandomSeed(), null, null, new SpawnerMobs.SpawnerConfig());
 			biomeProvider = worldType.createBiomeProvider(world);
 		}
 		allBiomes.clear();
diff --git a/src/main/java/net/betterthanadventure/utils/DataDumper.java b/src/main/java/net/betterthanadventure/utils/DataDumper.java
index 0092b83f9..25cbca191 100644
--- a/src/main/java/net/betterthanadventure/utils/DataDumper.java
+++ b/src/main/java/net/betterthanadventure/utils/DataDumper.java
@@ -195,6 +195,9 @@ public class DataDumper implements MinecraftAccessor {
     }
     @Override
     public File getMinecraftDir() {
+        if (!Global.isServer && Minecraft.getMinecraft(Minecraft.class) != null) { // Very hack way of making it pull the instance's mc directory when running from ingame
+            return Minecraft.getMinecraft(Minecraft.class).getMinecraftDir();
+        }
         if (minecraftDir == null){
             try {
                 minecraftDir = Minecraft.getAppDir("minecraft-bta"); // Client jar directory
diff --git a/src/main/java/net/minecraft/client/Minecraft.java b/src/main/java/net/minecraft/client/Minecraft.java
index d5b359d1c..0a3eb716d 100644
--- a/src/main/java/net/minecraft/client/Minecraft.java
+++ b/src/main/java/net/minecraft/client/Minecraft.java
@@ -5,12 +5,14 @@ import java.io.IOException;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Comparator;
+import java.util.List;
 import java.util.Random;
 
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.client.entity.ClientSkinVariantList;
 import net.minecraft.client.gui.toasts.GuiHudToasts;
 import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.world.SpawnerMobs;
 import net.minecraft.core.world.save.*;
 import net.minecraft.core.world.type.WorldType;
 import net.minecraft.core.world.type.WorldTypeGroups;
@@ -1634,7 +1636,6 @@ public class Minecraft
             if(!isGamePaused || isMultiplayerWorld())
             {
                 Debug.change("world");
-                theWorld.setAllowedMobSpawns(gameSettings.difficulty.value.canMobsSpawn(), true);
                 theWorld.tick();
                 Debug.change("misc");
             }
@@ -2051,7 +2052,7 @@ public class Minecraft
                     }
                 }
             }
-            World world = new World(saveHandler, worldName, seed, null, null);
+            World world = new World(saveHandler, worldName, seed, null, null, new SpawnerMobs.SpawnerConfig());
             if(world.isNewWorld)
             {
                 statsCounter.add(StatList.createWorldStat, 1);
@@ -2136,6 +2137,14 @@ public class Minecraft
         if(theWorld != null)
         {
             theWorld.saveWorldIndirectly(loadingScreen);
+            IChunkLoader loader = theWorld.saveHandler.getChunkLoader(theWorld.dimension);
+            while (loader.isSaving()) {
+                try {
+                    Thread.sleep(1);
+                } catch (InterruptedException e) {
+                    throw new RuntimeException(e);
+                }
+            }
             theWorld.getChunkProvider().unloadAllChunks();
             theWorld.onUnload();
         }
diff --git a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index 07e1ebc04..394f782ed 100644
--- a/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -274,6 +274,7 @@ public abstract class OptionsPages
             .withComponent(new BooleanOptionComponent(mc.gameSettings.loadAllSounds))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.allowSoundOverrides))
             .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
+            .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
         )
         .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
             .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 49be04e35..a1cf6e215 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -132,6 +132,7 @@ public class GameSettings {
 	public BooleanOption turnWithVehicle = new BooleanOption(this, "turnWithVehicle", true);
 	public BooleanOption disableCrashHandler = new BooleanOption(this,"disableCrashHandler",false);
 
+	public BooleanOption enableDevResourceLoading = new BooleanOption(this, "enableDevResourceLoading", false);
 	public BooleanOption downloadSoundfiles = new BooleanOption(this, "downloadSoundfiles", true);
 	public BooleanOption allowSoundOverrides = new BooleanOption(this, "allowSoundOverrides", false);
 	public BooleanOption loadAllSounds = new BooleanOption(this, "loadAllSounds", false);
diff --git a/src/main/java/net/minecraft/client/render/WorldRenderer.java b/src/main/java/net/minecraft/client/render/WorldRenderer.java
index 4a0dfa662..126cee60b 100644
--- a/src/main/java/net/minecraft/client/render/WorldRenderer.java
+++ b/src/main/java/net/minecraft/client/render/WorldRenderer.java
@@ -431,6 +431,8 @@ public class WorldRenderer
 				float deltaX = (float) mc.mouseInput.deltaX * sensitivity;
 				float deltaY = (float) mc.mouseInput.deltaY * sensitivity;
 
+//                System.out.printf("%s %s\n", deltaX, deltaY);
+
 				int l = 1;
 				if(mc.gameSettings.invertMouse.value) {
 					l = -1;
diff --git a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 8647daba8..342f51d47 100644
--- a/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -148,6 +148,7 @@ public class BlockModelDispatcher
 
         addDispatch(new TransparentBlockModel<>(Blocks.GLASS, false).withTextures("minecraft:block/glass"));
         addDispatch(new TransparentBlockModel<>(Blocks.GLASS_TINTED, false).withTextures("minecraft:block/glass_tinted"));
+        addDispatch(new TransparentBlockModel<>(Blocks.GLASS_STEEL, false).withTextures("minecraft:block/glass_steel"));
 
         addDispatch(new GrassBlockModel<>(Blocks.GRASS)
                 .withTextures("minecraft:block/grass_top", "minecraft:block/dirt", "minecraft:block/grass_side"));
@@ -329,6 +330,7 @@ public class BlockModelDispatcher
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_IRON).withTextures("minecraft:block/trapdoor_iron_top", "minecraft:block/trapdoor_iron_side"));
         addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_GLASS).withTextures("minecraft:block/glass", "minecraft:block/trapdoor_glass_side"));
         addDispatch(new TrapDoorPaintedBlockModel<>(Blocks.TRAPDOOR_PLANKS_PAINTED));
+        addDispatch(new TrapDoorBlockModel<>(Blocks.TRAPDOOR_STEEL).withTextures("minecraft:block/trapdoor_steel_top", "minecraft:block/trapdoor_steel_side"));
 
         addDispatch(new StandardBlockModel<>(Blocks.TNT).withTextures("minecraft:block/tnt_top", "minecraft:block/tnt_bottom", "minecraft:block/tnt_side"));
 
@@ -340,6 +342,8 @@ public class BlockModelDispatcher
         addDispatch(new PaintedDoorBlockModel<>(Blocks.DOOR_PLANKS_PAINTED_TOP, true).withTextures("minecraft:block/trapdoor_planks_oak_top", "minecraft:block/door_planks_oak_top"));
         addDispatch(new GlassDoorBlockModel<>(Blocks.DOOR_GLASS_BOTTOM).withTextures("minecraft:block/glass", "minecraft:block/door_glass_bottom"));
         addDispatch(new GlassDoorBlockModel<>(Blocks.DOOR_GLASS_TOP).withTextures("minecraft:block/glass", "minecraft:block/door_glass_top"));
+        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_BOTTOM).withTextures("minecraft:block/trapdoor_steel_top", "minecraft:block/door_steel_bottom"));
+        addDispatch(new DoorBlockModel<>(Blocks.DOOR_STEEL_TOP).withTextures("minecraft:block/trapdoor_steel_top", "minecraft:block/door_steel_top"));
 
         addDispatch(new TransparentBlockModel<>(Blocks.MESH, true).withTextures("minecraft:block/mesh"));
         addDispatch(new TransparentBlockModel<>(Blocks.MESH_GOLD, true).withTextures("minecraft:block/mesh_gold"));
diff --git a/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
index e078b6683..0b7471b8c 100644
--- a/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
+++ b/src/main/java/net/minecraft/client/render/block/model/RedstoneWireBlockModel.java
@@ -11,8 +11,8 @@ import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Color;
 
 public class RedstoneWireBlockModel<T extends Block> extends StandardBlockModel<T> {
-    protected IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
-    protected IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
+    protected final IconCoordinate wireStraight = TextureRegistry.getTexture("minecraft:block/wire_redstone_straight");
+    protected final IconCoordinate wireCross = TextureRegistry.getTexture("minecraft:block/wire_redstone_cross");
     public RedstoneWireBlockModel(Block block) {
         super(block);
         withTextures("minecraft:block/wire_redstone_cross");
@@ -22,9 +22,11 @@ public class RedstoneWireBlockModel<T extends Block> extends StandardBlockModel<
     public boolean render(Tessellator tessellator, int x, int y, int z) {
         block.setBlockBoundsBasedOnState(renderBlocks.blockAccess, x, y, z);
         int meta = renderBlocks.blockAccess.getBlockMetadata(x, y, z);
+        IconCoordinate straight = wireStraight;
+        IconCoordinate cross = wireCross;
         if(renderBlocks.overrideBlockTexture != null)
         {
-            wireCross = renderBlocks.overrideBlockTexture;
+            cross = renderBlocks.overrideBlockTexture;
         }
         float brightness = 1.0f;
         if(LightmapHelper.isLightmapEnabled()) {
@@ -113,94 +115,94 @@ public class RedstoneWireBlockModel<T extends Block> extends StandardBlockModel<
                 float s = south ? 0 : onePix * 5;
                 float n = north ? 0 : onePix * 5;
 
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  wireCross.getSubIconU(1 - e), wireCross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  wireCross.getSubIconU(1 - e), wireCross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  wireCross.getSubIconU(w),     wireCross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  wireCross.getSubIconU(w),     wireCross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  cross.getSubIconU(1 - e), cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  cross.getSubIconU(w),     cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  cross.getSubIconU(w),     cross.getSubIconV(1 - s));
 
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  wireCross.getSubIconU(1 - e), wireCross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  wireCross.getSubIconU(w),     wireCross.getSubIconV(1 - s));
-                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  wireCross.getSubIconU(w),     wireCross.getSubIconV(n));
-                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  wireCross.getSubIconU(1 - e), wireCross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMax - s,  cross.getSubIconU(1 - e), cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMax - s,  cross.getSubIconU(w),     cross.getSubIconV(1 - s));
+                tessellator.addVertexWithUV(xMin + w, (float)y + renderOffset, zMin + n,  cross.getSubIconU(w),     cross.getSubIconV(n));
+                tessellator.addVertexWithUV(xMax - e, (float)y + renderOffset, zMin + n,  cross.getSubIconU(1 - e), cross.getSubIconV(n));
 
 
             } else {
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireCross.getIconUMax(), wireCross.getIconVMax());
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireCross.getIconUMax(), wireCross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireCross.getIconUMin(), wireCross.getIconVMin());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireCross.getIconUMin(), wireCross.getIconVMax());
-
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireCross.getIconUMax(), wireCross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireCross.getIconUMin(), wireCross.getIconVMax());
-                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireCross.getIconUMin(), wireCross.getIconVMin());
-                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireCross.getIconUMax(), wireCross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+
+                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, cross.getIconUMax(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, cross.getIconUMin(), cross.getIconVMax());
+                tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, cross.getIconUMin(), cross.getIconVMin());
+                tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, cross.getIconUMax(), cross.getIconVMin());
             }
 
         } else if (type == 1) { // East-West
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireStraight.getIconUMin(), wireStraight.getIconVMax());
-
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireStraight.getIconUMax(), wireStraight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMax(), straight.getIconVMin());
         } else { // North-South
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, wireStraight.getIconUMin(), wireStraight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMax, straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y + renderOffset, zMin, straight.getIconUMin(), straight.getIconVMax());
         }
 
         if (northUp){
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(xMin, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y + 1, z + renderOffset,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y,     z + renderOffset,   straight.getIconUMax(), straight.getIconVMin());
         }
         if (southUp){
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-
-            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(xMax, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(xMin, (float)y + 1, z + 1 - renderOffset,   straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMin, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(xMax, (float)y,     z + 1 - renderOffset,   straight.getIconUMax(), straight.getIconVMax());
         }
         if (eastUp){
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
+
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + 1 - renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
         }
         if (westUp){
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   wireStraight.getIconUMin(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   wireStraight.getIconUMax(), wireStraight.getIconVMax());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   wireStraight.getIconUMax(), wireStraight.getIconVMin());
-            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   wireStraight.getIconUMin(), wireStraight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
+
+            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMin,   straight.getIconUMin(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMin,   straight.getIconUMax(), straight.getIconVMax());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y,     zMax,   straight.getIconUMax(), straight.getIconVMin());
+            tessellator.addVertexWithUV(x + renderOffset, (float)y + 1, zMax,   straight.getIconUMin(), straight.getIconVMin());
         }
 
         return true;
diff --git a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index c22357a62..6cc41a2fc 100644
--- a/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -206,6 +206,7 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new StandardItemModel(Items.ROPE, "minecraft"));
 
         addDispatch(new StandardItemModel(Items.WAND_MONSTER_SPAWNER, "minecraft").setFull3D());
+        addDispatch(new StandardItemModel(Items.DOOR_STEEL, "minecraft"));
 
         addDispatch(new StandardItemModel(Items.RECORD_13, "minecraft"));
         addDispatch(new StandardItemModel(Items.RECORD_CAT, "minecraft"));
